uses
  Math, SysUtils;

procedure Order(var a, b: Integer);
var
  t: Integer;
begin
  if a <= b then exit;
  t := a; a := b; b := t;
end;

var
  x, y: array of Integer;

function Count(xa, ya, xb, yb: Integer): Integer;
var
  i: Integer;
begin
  Result := 0;
  for i := 0 to High(x) do
    Inc(Result, Ord(InRange(x[i], xa, xb) and InRange(y[i], ya, yb)));
end;

var
  fi, fo, fa: TextFile;
  i, N, S, xa, ya, xb, yb, ca, co: Integer;
begin
  AssignFile(fi, ParamStr(1)); Reset(fi);
  Read(fi, N, S);
  SetLength(x, N);
  SetLength(y, N);
  for i := 0 to N - 1 do Read(fi, x[i], y[i]);
  CloseFile(fi);

  AssignFile(fa, ParamStr(3)); Reset(fa);
  Read(fa, xa, ya, xb, yb);
  Order(xa, xb);
  Order(ya, yb);
  if (xb - xa) * (yb - ya) > S then Halt(3);
  ca := Count(xa, ya, xb, yb);
  CloseFile(fa);

  try
    AssignFile(fo, ParamStr(2)); Reset(fo);
    Read(fo, xa, ya, xb, yb);
    Order(xa, xb);
    Order(ya, yb);
    if (xb - xa) * (yb - ya) > S then begin
      Writeln('Area too large');
      Halt(1);
    end;
    co := Count(xa, ya, xb, yb);
    if co < ca then begin
      Writeln('Only ', co, ' trees instead of ', ca);
      Halt(1);
    end;
    if co > ca then begin
      Writeln('!!! ', co, ' trees instead of ', ca);
      Halt(3);
    end;
    CloseFile(fo);
  except
    Halt(2);
  end;
end.
